
#include <windows.h>
#include <time.h>
#include <string>
#include <SDL.h>
#include <SDL_image.h>
#include "Tools.h"
#include "SDLgraph.h"
#include "main.h"
#include "schneee.h"

using namespace std;

struct aFlake
{
	unsigned int x,y;
};


const unsigned int numFlakes=1000;
aFlake *Flakes;


SDL_Surface *schneeman=NULL;


void initSchnee()
{

   schneeman=IMG_Load("schneeman.jpg");
   if (!schneeman) error("schneeman.jpg failed!");

   schneeman=SDL_ConvertSurfaceFormat(schneeman,SDL_PIXELFORMAT_ARGB8888,0);

   SDL_SetColorKey(schneeman,true,RGBA32(0,0,0,255));

   	Flakes = new aFlake[numFlakes];

	for (int i=0;i<numFlakes;i++)
	{
		Flakes[i].x=rand()%screenwidth;
		Flakes[i].y=rand()%screenheight;
	}

}




void processSchnee(SDL_Surface* screen)
{
	
	SDL_FillRect(screen,NULL,0);



	for (int i=0;i<numFlakes;i++)
	{
			
			Flakes[i].y++;
			if (Flakes[i].y>=screenheight-1) Flakes[i].y=0;


			int r=rand()%3;
			if (r==1) Flakes[i].x++;
			if (r==2) Flakes[i].x--;

			putpixelSurface(screen,Flakes[i].x,Flakes[i].y,RGBA32(255,255,255,255));

	}

	SDL_BlitSurface(schneeman,NULL,screen,NULL);



}


void closeSchnee()
{

	delete [] Flakes;

	SDL_FreeSurface(schneeman);
}