#pragma once

#include <string>
#include <SDL.h>


SDL_Texture* LoadTexture(std::string filename);
SDL_Surface* LoadIMG(std::string filename);


Uint32 RGBA32(Uint8 r, Uint8 g,Uint8 b, Uint8 a);
void GetRGBA32(Uint32 c, Uint8 &r, Uint8 &g, Uint8 &b, Uint8 &a);



void putpixelSurface(SDL_Surface *surface, int x, int y, Uint32 pixel);
Uint32 getpixelSurface(SDL_Surface *surface, int x, int y);


void putpixelBuffer(Uint32 *buf, int x, int y, Uint32 pixel, Uint32 width);